tests: make bt_diff check a single file pair
[babeltrace.git] / tests / utils / utils.sh
CommitLineData
644e0364
MJ
1#!/bin/bash
2
3# Copyright (c) 2019 Michael Jeanson <mjeanson@efficios.com>
4# Copyright (C) 2019 Philippe Proulx <pproulx@efficios.com>
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; under version 2 of the License.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License along
16# with this program; if not, write to the Free Software Foundation, Inc.,
17# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
18
19# This file is meant to be sourced at the start of shell script-based tests.
20
21
22# Error out when encountering an undefined variable
23set -u
24
9c5dd55a
MJ
25# If "readlink -f" is available, get a resolved absolute path to the
26# tests source dir, otherwise make do with a relative path.
644e0364 27scriptdir="$(dirname "${BASH_SOURCE[0]}")"
9c5dd55a
MJ
28if readlink -f "." >/dev/null 2>&1; then
29 testsdir=$(readlink -f "$scriptdir/..")
30else
31 testsdir="$scriptdir/.."
32fi
644e0364 33
5058d31b
JR
34# The OS on which we are running. See [1] for possible values of 'uname -s'.
35# We do a bit of translation to ease our life down the road for comparison.
36# Export it so that called executables can use it.
37# [1] https://en.wikipedia.org/wiki/Uname#Examples
38if [ "x${BT_OS_TYPE:-}" = "x" ]; then
39 BT_OS_TYPE="$(uname -s)"
40 case "$BT_OS_TYPE" in
41 MINGW*)
42 BT_OS_TYPE="mingw"
43 ;;
44 Darwin)
45 BT_OS_TYPE="darwin"
46 ;;
47 Linux)
48 BT_OS_TYPE="linux"
49 ;;
df9db467
JR
50 CYGWIN*)
51 BT_OS_TYPE="cygwin"
52 ;;
5058d31b
JR
53 *)
54 BT_OS_TYPE="unsupported"
55 ;;
56 esac
57fi
58export BT_OS_TYPE
59
644e0364
MJ
60# Allow overriding the source and build directories
61if [ "x${BT_TESTS_SRCDIR:-}" = "x" ]; then
9c5dd55a 62 BT_TESTS_SRCDIR="$testsdir"
644e0364
MJ
63fi
64export BT_TESTS_SRCDIR
65
66if [ "x${BT_TESTS_BUILDDIR:-}" = "x" ]; then
9c5dd55a 67 BT_TESTS_BUILDDIR="$testsdir"
644e0364
MJ
68fi
69export BT_TESTS_BUILDDIR
70
71# By default, it will not source tap.sh. If you to tap output directly from
72# the test script, define the 'SH_TAP' variable to '1' before sourcing this
73# script.
74if [ "x${SH_TAP:-}" = x1 ]; then
1d970e04 75 # shellcheck source=./tap/tap.sh
644e0364
MJ
76 . "${BT_TESTS_SRCDIR}/utils/tap/tap.sh"
77fi
78
79# Allow overriding the babeltrace2 executables
80if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
4881a20e 81 BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
5058d31b 82 if [ "$BT_OS_TYPE" = "mingw" ]; then
27e2c58d
JR
83 BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
84 fi
644e0364
MJ
85fi
86export BT_TESTS_BT2_BIN
87
644e0364
MJ
88# TODO: Remove when bindings/python/bt2/test_plugin.py is fixed
89BT_PLUGINS_PATH="${BT_TESTS_BUILDDIR}/../src/plugins"
90
91# Allow overriding the babeltrace2 plugin path
92if [ "x${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" = "x" ]; then
93 BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text"
94fi
95
b14c7bf1
MJ
96if [ "x${BT_TESTS_PROVIDER_DIR:-}" = "x" ]; then
97 BT_TESTS_PROVIDER_DIR="${BT_TESTS_BUILDDIR}/../src/python-plugin-provider/.libs"
98fi
99
644e0364
MJ
100# Allow overriding the babeltrace2 executables
101if [ "x${BT_TESTS_PYTHONPATH:-}" = "x" ]; then
102 BT_TESTS_PYTHONPATH="${BT_TESTS_BUILDDIR}/../src/bindings/python/bt2/build/build_lib"
103fi
104
105
106### External Tools ###
107if [ "x${BT_TESTS_AWK_BIN:-}" = "x" ]; then
108 BT_TESTS_AWK_BIN="awk"
109fi
110export BT_TESTS_AWK_BIN
111
112if [ "x${BT_TESTS_GREP_BIN:-}" = "x" ]; then
113 BT_TESTS_GREP_BIN="grep"
114fi
115export BT_TESTS_GREP_BIN
116
117if [ "x${BT_TESTS_PYTHON_BIN:-}" = "x" ]; then
118 BT_TESTS_PYTHON_BIN="python3"
119fi
120export BT_TESTS_PYTHON_BIN
121
e23e08c4
MJ
122if [ "x${BT_TESTS_PYTHON_CONFIG_BIN:-}" = "x" ]; then
123 BT_TESTS_PYTHON_CONFIG_BIN="python3-config"
124fi
242ddcb7 125export BT_TESTS_PYTHON_CONFIG_BIN
e23e08c4 126
644e0364
MJ
127if [ "x${BT_TESTS_SED_BIN:-}" = "x" ]; then
128 BT_TESTS_SED_BIN="sed"
129fi
130export BT_TESTS_SED_BIN
131
132
133# Data files path
134BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
135BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
644e0364 136
22703f66
SM
137# Run the Babeltrace CLI, redirecting stdout and stderr to specified files.
138#
139# $1: file to redirect stdout to
140# $2: file to redirect stderr to
141# remaining args: arguments to pass to the CLI
142#
143# Return the exit code of the CLI.
144
145bt_cli() {
146 local stdout_file="$1"
147 local stderr_file="$2"
148 shift 2
149 local args=("$@")
150
151 run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$stdout_file" 2>"$stderr_file"
152}
644e0364
MJ
153
154### Diff Functions ###
155
a70b6702
SM
156# Check the differences between two files (typically some expected output vs
157# some actual output). If there are differences, print the diff to stderr.
ff89ed28 158#
a70b6702
SM
159# $1: file 1 (expected)
160# $2: file 2 (actual)
ff89ed28 161#
a70b6702 162# Return 0 if there's no difference, and 1 if there are.
ff89ed28 163#
a70b6702
SM
164# Note that this function modifies the actual output file ($2) _in-place_ to
165# remove any \r character.
166
ff89ed28 167bt_diff() {
a70b6702
SM
168 local expected_file="$1"
169 local actual_file="$2"
170 shift 2
ff89ed28 171 local args=("$@")
ff89ed28
MJ
172 local ret=0
173 local temp_diff
174
175 temp_diff="$(mktemp -t diff.XXXXXX)"
176
177 # Strip any \r present due to Windows (\n -> \r\n).
178 # "diff --string-trailing-cr" is not used since it is not present on
179 # Solaris.
a70b6702 180 "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_file"
ff89ed28 181
a70b6702
SM
182 if ! diff -u "$expected_file" "$actual_file" > "$temp_diff"; then
183 echo "ERROR: for '${args[*]}': output does not match:" >&2
ff89ed28
MJ
184 cat "$temp_diff" >&2
185 ret=1
186 fi
187
188 rm -f "$temp_diff"
189
190 return $ret
191}
192
58db335e
FD
193# Checks the difference between:
194#
195# 1. What the CLI outputs on its standard output when given the arguments
196# "$@" (excluding the first two arguments).
197# 2. The file with path "$1".
198#
199# And the difference between:
200#
201# 1. What the CLI outputs on its standard error when given the arguments
202# "$@" (excluding the first two arguments).
203# 2. The file with path "$2".
644e0364
MJ
204#
205# Returns 0 if there's no difference, and 1 if there is, also printing
206# said difference to the standard error.
207bt_diff_cli() {
58db335e
FD
208 local expected_stdout_file="$1"
209 local expected_stderr_file="$2"
210 shift 2
53cc240b
MJ
211 local args=("$@")
212
58db335e
FD
213 local temp_stdout_output_file
214 local temp_stderr_output_file
644e0364 215 local ret=0
a70b6702
SM
216 local ret_stdout
217 local ret_stderr
644e0364 218
ff89ed28
MJ
219 temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
220 temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
644e0364 221
58db335e 222 # Run the CLI to get a detailed file.
22703f66 223 bt_cli "$temp_stdout_output_file" "$temp_stderr_output_file" "${args[@]}"
58db335e 224
a70b6702
SM
225 bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "${args[@]}"
226 ret_stdout=$?
227 bt_diff "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
228 ret_stderr=$?
229
230 if ((ret_stdout != 0 || ret_stderr != 0)); then
231 ret=1
232 fi
58db335e 233
ff89ed28 234 rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
644e0364 235
ff89ed28
MJ
236 return $ret
237}
238
239# Checks the difference between:
240#
241# 1. What the CLI outputs on its standard output when given the arguments
242# "$@" (excluding the first two arguments), sorted with the default "sort".
243# 2. The file with path "$1".
244#
245# And the difference between:
246#
247# 1. What the CLI outputs on its standard error when given the arguments
248# "$@" (excluding the first two arguments).
249# 2. The file with path "$2".
250#
251# Returns 0 if there's no difference, and 1 if there is, also printing
252# said difference to the standard error.
253bt_diff_cli_sorted() {
254 local expected_stdout_file="$1"
255 local expected_stderr_file="$2"
256 shift 2
257 local args=("$@")
258
259 local temp_stdout_output_file
260 local temp_stderr_output_file
261 local ret=0
a70b6702
SM
262 local ret_stdout
263 local ret_stderr
ff89ed28
MJ
264
265 temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
266 temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
267
268 # Run the CLI to get a detailed file.
22703f66 269 bt_cli "$temp_stdout_output_file" "$temp_stderr_output_file" "${args[@]}"
ff89ed28
MJ
270
271 # Sort the stdout file, use a subshell to do it in-place
272 # shellcheck disable=SC2005
273 echo "$(LC_ALL=C sort "$temp_stdout_output_file")" > "$temp_stdout_output_file"
274
a70b6702
SM
275 bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "${args[@]}"
276 ret_stdout=$?
277 bt_diff "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
278 ret_stderr=$?
279
280 if ((ret_stdout != 0 || ret_stderr != 0)); then
281 ret=1
282 fi
644e0364 283
ff89ed28 284 rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
644e0364
MJ
285
286 return $ret
287}
288
53cc240b
MJ
289# Checks the difference between the content of the file with path "$1"
290# and the output of the CLI when called on the directory path "$2" with
291# the arguments '-c sink.text.details' and the rest of the arguments to
292# this function.
644e0364
MJ
293#
294# Returns 0 if there's no difference, and 1 if there is, also printing
295# said difference to the standard error.
296bt_diff_details_ctf_single() {
58db335e 297 local expected_stdout_file="$1"
53cc240b
MJ
298 local trace_dir="$2"
299 shift 2
300 local extra_details_args=("$@")
58db335e 301 expected_stderr_file="/dev/null"
644e0364
MJ
302
303 # Compare using the CLI with `sink.text.details`
58db335e 304 bt_diff_cli "$expected_stdout_file" "$expected_stderr_file" "$trace_dir" "-c" "sink.text.details" "${extra_details_args[@]}"
644e0364
MJ
305}
306
307# Calls bt_diff_details_ctf_single(), except that "$1" is the path to a
308# program which generates the CTF trace to compare to. The program "$1"
309# receives the path to a temporary, empty directory where to write the
310# CTF trace as its first argument.
311bt_diff_details_ctf_gen_single() {
312 local ctf_gen_prog_path="$1"
58db335e 313 local expected_stdout_file="$2"
53cc240b
MJ
314 shift 2
315 local extra_details_args=("$@")
644e0364
MJ
316
317 local temp_trace_dir
318 local ret
319
320 temp_trace_dir="$(mktemp -d)"
321
322 # Run the CTF trace generator program to get a CTF trace
323 if ! "$ctf_gen_prog_path" "$temp_trace_dir" 2>/dev/null; then
324 echo "ERROR: \"$ctf_gen_prog_path\" \"$temp_trace_dir\" failed" >&2
325 rm -rf "$temp_trace_dir"
326 return 1
327 fi
328
329 # Compare using the CLI with `sink.text.details`
58db335e 330 bt_diff_details_ctf_single "$expected_stdout_file" "$temp_trace_dir" "${extra_details_args[@]}"
644e0364
MJ
331 ret=$?
332 rm -rf "$temp_trace_dir"
333 return $ret
334}
335
336
337### Functions ###
338
339check_coverage() {
340 coverage run "$@"
341}
342
343# Execute a shell command in the appropriate environment to have access to the
344# bt2 Python bindings.
345run_python_bt2() {
e23e08c4
MJ
346 local env_args
347
348 env_args=(
349 "BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1" \
350 "BABELTRACE_PLUGIN_PATH=${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
351 "LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR}" \
352 "BT_CTF_TRACES_PATH=${BT_CTF_TRACES_PATH}" \
353 "BT_PLUGINS_PATH=${BT_PLUGINS_PATH}" \
354 "PYTHONPATH=${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python"
355 )
644e0364 356
0408934a
SM
357 local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
358
644e0364 359 # Set the library search path so the python interpreter can load libbabeltrace2
df9db467 360 if [ "$BT_OS_TYPE" = "mingw" ] || [ "$BT_OS_TYPE" = "cygwin" ]; then
e23e08c4 361 env_args+=("PATH=${main_lib_path}:${PATH:-}")
5058d31b 362 elif [ "$BT_OS_TYPE" = "darwin" ]; then
e23e08c4 363 env_args+=("DYLD_LIBRARY_PATH=${main_lib_path}:${DYLD_LIBRARY_PATH:-}")
644e0364 364 else
e23e08c4
MJ
365 env_args+=("LD_LIBRARY_PATH=${main_lib_path}:${LD_LIBRARY_PATH:-}")
366 fi
367
368 # On Windows, an embedded Python interpreter needs a way to locate the path
369 # to it's internal modules, set the prefix from python-config to the
370 # PYTHONHOME variable.
371 if [ "$BT_OS_TYPE" = "mingw" ]; then
372 env_args+=("PYTHONHOME=$($BT_TESTS_PYTHON_CONFIG_BIN --prefix)")
644e0364
MJ
373 fi
374
e23e08c4 375 env "${env_args[@]}" "$@"
644e0364
MJ
376}
377
378# Set the environment and run python tests in the directory.
379#
380# $1 : The directory containing the python test scripts
381# $2 : The pattern to match python test script names (optional)
644e0364
MJ
382run_python_bt2_test() {
383 local test_dir="$1"
a818a617 384 local test_pattern="${2:-'*'}" # optional, if none default to "*"
644e0364
MJ
385
386 local ret
387 local test_runner_args=()
388
389 test_runner_args+=("$test_dir")
390 if [ "x${test_pattern}" != "x" ]; then
391 test_runner_args+=("${test_pattern}")
392 fi
393
394 if test "x${BT_TESTS_COVERAGE:-}" = "x1"; then
395 python_exec="check_coverage"
396 else
397 python_exec="${BT_TESTS_PYTHON_BIN}"
398 fi
399
400 run_python_bt2 \
401 "${python_exec}" \
402 "${BT_TESTS_SRCDIR}/utils/python/testrunner.py" \
a818a617
FD
403 --pattern "$test_pattern" \
404 "$test_dir" \
405
644e0364
MJ
406 ret=$?
407
408 if test "x${BT_TESTS_COVERAGE_REPORT:-}" = "x1"; then
409 coverage report -m
410 fi
411
412 if test "x${BT_TESTS_COVERAGE_HTML:-}" = "x1"; then
413 coverage html
414 fi
415
416 return $ret
417}
This page took 0.043508 seconds and 4 git commands to generate.